library("extrafont")
loadfonts()

#####READ IN DATA#####
nys.haps <- read.csv("GR.OpticalDensity/data_output/Nys2HapsMeans.OD.csv", sep=",", as.is=TRUE)
ypd.haps <- read.csv("GR.OpticalDensity/data_output/YPDHapsMeans.OD.csv", sep=",", as.is=TRUE)

nys.contr <- read.csv("GR.OpticalDensity/data_output/Nys2HapsContrasts.OD.csv", sep=",", as.is=TRUE)
ypd.contr <- read.csv("GR.OpticalDensity/data_output/YPDHapsContrasts.OD.csv", sep=",", as.is=TRUE)

nys.dips <- read.csv("GR.OpticalDensity/data_output/Nys2DipsMMeans.OD.csv", sep=",", as.is=TRUE)
nys.dips.contr <- read.csv("GR.OpticalDensity/data_output/Nys2DipsMContrasts.OD.csv", sep=",", as.is=TRUE)
nys.dips.t <- read.csv("GR.OpticalDensity/data_output/Nys2DipsTMeans.OD.csv", sep=",", as.is=TRUE)

ypd.dips <- read.csv("GR.OpticalDensity/data_output/YPDDipsMMeans.OD.csv", sep=",", as.is=TRUE)
ypd.dips.contr <- read.csv("GR.OpticalDensity/data_output/YPDDipsMContrasts.OD.csv", sep=",", as.is=TRUE)
ypd.dips.t <- read.csv("GR.OpticalDensity/data_output/YPDDipsTMeans.OD.csv", sep=",", as.is=TRUE)

#####SET UP DATA#####
#'make a column with line names as we usually use them
nys.haps$line <- ""

for (i in 1:length(nys.haps$line)){
  for (j in 1:4){
    if(nys.haps[i,j]=="m"){
      if(j==1){
        nys.haps$line[i] <- paste(nys.haps$line[i], "8m", sep="") 
      }
      if(j==2){
        nys.haps$line[i] <- paste(nys.haps$line[i], "12m", sep="") 
      }
      if(j==3){
        nys.haps$line[i] <- paste(nys.haps$line[i], "45m", sep="") 
      }
      if(j==4){
        nys.haps$line[i] <- paste(nys.haps$line[i], "58m", sep="") 
      }
    }
  }
}

ypd.haps$line <- ""

for (i in 1:length(ypd.haps$line)){
  for (j in 1:4){
    if(ypd.haps[i,j]=="m"){
      if(j==1){
        ypd.haps$line[i] <- paste(ypd.haps$line[i], "8m", sep="") 
      }
      if(j==2){
        ypd.haps$line[i] <- paste(ypd.haps$line[i], "12m", sep="") 
      }
      if(j==3){
        ypd.haps$line[i] <- paste(ypd.haps$line[i], "45m", sep="") 
      }
      if(j==4){
        ypd.haps$line[i] <- paste(ypd.haps$line[i], "58m", sep="") 
      }
    }
  }
}

nys.dips$line <- ""

for (i in 1:length(nys.dips$line)){
  for (j in 1:4){
    if(nys.dips[i,j]=="m"){
      if(j==1){
        nys.dips$line[i] <- paste(nys.dips$line[i], "8m", sep="") 
      }
      if(j==2){
        nys.dips$line[i] <- paste(nys.dips$line[i], "12m", sep="") 
      }
      if(j==3){
        nys.dips$line[i] <- paste(nys.dips$line[i], "45m", sep="") 
      }
      if(j==4){
        nys.dips$line[i] <- paste(nys.dips$line[i], "58m", sep="") 
      }
    }
  }
}

ypd.dips$line <- ""

for (i in 1:length(ypd.dips$line)){
  for (j in 1:4){
    if(ypd.dips[i,j]=="m"){
      if(j==1){
        ypd.dips$line[i] <- paste(ypd.dips$line[i], "8m", sep="") 
      }
      if(j==2){
        ypd.dips$line[i] <- paste(ypd.dips$line[i], "12m", sep="") 
      }
      if(j==3){
        ypd.dips$line[i] <- paste(ypd.dips$line[i], "45m", sep="") 
      }
      if(j==4){
        ypd.dips$line[i] <- paste(ypd.dips$line[i], "58m", sep="") 
      }
    }
  }
}

nys.dips.t$line <- ""

for (i in 1:length(nys.dips.t$line)){
  for (j in 1:4){
    if(nys.dips.t[i,j]=="m"){
      if(j==1){
        nys.dips.t$line[i] <- paste(nys.dips.t$line[i], "8m", sep="") 
      }
      if(j==2){
        nys.dips.t$line[i] <- paste(nys.dips.t$line[i], "12m", sep="") 
      }
      if(j==3){
        nys.dips.t$line[i] <- paste(nys.dips.t$line[i], "45m", sep="") 
      }
      if(j==4){
        nys.dips.t$line[i] <- paste(nys.dips.t$line[i], "58m", sep="") 
      }
    }
      if(nys.dips.t[i,j]=="t"){
        if(j==1){
          nys.dips.t$line[i] <- paste(nys.dips.t$line[i], "8t", sep="") 
        }
        if(j==2){
          nys.dips.t$line[i] <- paste(nys.dips.t$line[i], "12t", sep="") 
        }
        if(j==3){
          nys.dips.t$line[i] <- paste(nys.dips.t$line[i], "45t", sep="") 
        }
        if(j==4){
          nys.dips.t$line[i] <- paste(nys.dips.t$line[i], "58t", sep="") 
        }
    }
  }
}

ypd.dips.t$line <- ""

for (i in 1:length(ypd.dips.t$line)){
  for (j in 1:4){
    if(ypd.dips.t[i,j]=="m"){
      if(j==1){
        ypd.dips.t$line[i] <- paste(ypd.dips.t$line[i], "8m", sep="") 
      }
      if(j==2){
        ypd.dips.t$line[i] <- paste(ypd.dips.t$line[i], "12m", sep="") 
      }
      if(j==3){
        ypd.dips.t$line[i] <- paste(ypd.dips.t$line[i], "45m", sep="") 
      }
      if(j==4){
        ypd.dips.t$line[i] <- paste(ypd.dips.t$line[i], "58m", sep="") 
      }
    }
    if(ypd.dips.t[i,j]=="t"){
      if(j==1){
        ypd.dips.t$line[i] <- paste(ypd.dips.t$line[i], "8t", sep="") 
      }
      if(j==2){
        ypd.dips.t$line[i] <- paste(ypd.dips.t$line[i], "12t", sep="") 
      }
      if(j==3){
        ypd.dips.t$line[i] <- paste(ypd.dips.t$line[i], "45t", sep="") 
      }
      if(j==4){
        ypd.dips.t$line[i] <- paste(ypd.dips.t$line[i], "58t", sep="") 
      }
    }
  }
}

#'manually add the wt name
nys.haps$line[1] <- "wt"
ypd.haps$line[1] <- "wt"
nys.dips$line[1] <- "wt"
ypd.dips$line[1] <- "wt"
nys.dips.t$line[1] <- "wt"
ypd.dips.t$line[1] <- "wt"

#'make a column with line names for use with contrasts
nys.haps$geno <- paste(nys.haps$nbm8, nys.haps$nbm12, nys.haps$nbm45, nys.haps$nbm58, sep=",")
ypd.haps$geno <- paste(ypd.haps$nbm8, ypd.haps$nbm12, ypd.haps$nbm45, ypd.haps$nbm58, sep=",")
nys.dips$geno <- paste(nys.dips$nbm8, nys.dips$nbm12, nys.dips$nbm45, nys.dips$nbm58, sep=",")
ypd.dips$geno <- paste(ypd.dips$nbm8, ypd.dips$nbm12, ypd.dips$nbm45, ypd.dips$nbm58, sep=",")

#####SETTING UP PLOTTING#####
#'make 2 new columns with lty values 
#'lty1 == 1 if double mutant significantly different from the first single mutant or if single mutant significantly different from the ancestor
#'lty2 == 1 if double mutant significantly different from the second single mutant or if single mutant significantly different from the ancestor
#'otherwise, lty==3
nys.haps$lty1 <- NA
nys.haps$lty2 <- NA
ypd.haps$lty1 <- NA
ypd.haps$lty2 <- NA
nys.dips$lty1 <- NA
nys.dips$lty2 <- NA
ypd.dips$lty1 <- NA
ypd.dips$lty2 <- NA

#'write function to set lty
set_lty <- function(data, contr, sngl1, sngl2, dbl, wt){  
  if (contr[contr$contrast==paste(data[data$line==sngl1,]$geno, data[data$line==dbl,]$geno, sep=" - "),]$p<0.05){
    data[data$line==dbl,]$lty1 <- 1
  }else{data[data$line==dbl,]$lty1 <- 3}
  
  if (contr[contr$contrast==paste(data[data$line==sngl2,]$geno, data[data$line==dbl,]$geno, sep=" - "),]$p<0.05){
    data[data$line==dbl,]$lty2 <- 1
  }else{data[data$line==dbl,]$lty2 <- 3}
  
  if (contr[contr$contrast==paste(data[data$line==wt,]$geno, data[data$line==sngl1,]$geno, sep=" - "),]$p<0.05){
    data[data$line==sngl1,]$lty1 <- 1
  }else{data[data$line==sngl1,]$lty1 <- 3}
  
  if (contr[contr$contrast==paste(data[data$line==wt,]$geno, data[data$line==sngl2,]$geno, sep=" - "),]$p<0.05){
    data[data$line==sngl2,]$lty1 <- 1
  }else{data[data$line==sngl2,]$lty1 <- 3}
  
  return(data)
}

#'set ltys
nys.haps <- set_lty(nys.haps, nys.contr, "8m", "12m", "8m12m", "wt")
nys.haps <- set_lty(nys.haps, nys.contr, "45m", "8m", "8m45m", "wt")
nys.haps <- set_lty(nys.haps, nys.contr, "58m", "8m", "8m58m", "wt")
nys.haps <- set_lty(nys.haps, nys.contr, "45m", "12m", "12m45m", "wt")
nys.haps <- set_lty(nys.haps, nys.contr, "58m", "12m", "12m58m", "wt")
nys.haps <- set_lty(nys.haps, nys.contr, "45m", "58m", "45m58m", "wt")

ypd.haps <- set_lty(ypd.haps, ypd.contr, "8m", "12m", "8m12m", "wt")
ypd.haps <- set_lty(ypd.haps, ypd.contr, "45m", "8m", "8m45m", "wt")
ypd.haps <- set_lty(ypd.haps, ypd.contr, "58m", "8m", "8m58m", "wt")
ypd.haps <- set_lty(ypd.haps, ypd.contr, "45m", "12m", "12m45m", "wt")
ypd.haps <- set_lty(ypd.haps, ypd.contr, "58m", "12m", "12m58m", "wt")
ypd.haps <- set_lty(ypd.haps, ypd.contr, "45m", "58m", "45m58m", "wt")

nys.dips <- set_lty(nys.dips, nys.dips.contr, "8m", "12m", "8m12m", "wt")
nys.dips <- set_lty(nys.dips, nys.dips.contr, "45m", "8m", "8m45m", "wt")
nys.dips <- set_lty(nys.dips, nys.dips.contr, "58m", "8m", "8m58m", "wt")
nys.dips <- set_lty(nys.dips, nys.dips.contr, "45m", "12m", "12m45m", "wt")
nys.dips <- set_lty(nys.dips, nys.dips.contr, "58m", "12m", "12m58m", "wt")
nys.dips <- set_lty(nys.dips, nys.dips.contr, "45m", "58m", "45m58m", "wt")

ypd.dips <- set_lty(ypd.dips, ypd.dips.contr, "8m", "12m", "8m12m", "wt")
ypd.dips <- set_lty(ypd.dips, ypd.dips.contr, "45m", "8m", "8m45m", "wt")
ypd.dips <- set_lty(ypd.dips, ypd.dips.contr, "58m", "8m", "8m58m", "wt")
ypd.dips <- set_lty(ypd.dips, ypd.dips.contr, "45m", "12m", "12m45m", "wt")
ypd.dips <- set_lty(ypd.dips, ypd.dips.contr, "58m", "12m", "12m58m", "wt")
ypd.dips <- set_lty(ypd.dips, ypd.dips.contr, "45m", "58m", "45m58m", "wt")

#'set colours of points
nys.haps$col <- NA
nys.haps[nys.haps$line=="wt",]$col <- "#BEBEBE"
nys.haps[nys.haps$line=="8m",]$col <- "#8B0000"
nys.haps[nys.haps$line=="12m",]$col <- "#87CEEB"
nys.haps[nys.haps$line=="45m",]$col <- "#FFD700"
nys.haps[nys.haps$line=="58m",]$col <- "#008B00"
nys.haps[nys.haps$line=="8m12m",]$col <- "#000000"
nys.haps[nys.haps$line=="8m45m",]$col <- "#000000"
nys.haps[nys.haps$line=="8m58m",]$col <- "#000000"
nys.haps[nys.haps$line=="12m45m",]$col <- "#000000"
nys.haps[nys.haps$line=="12m58m",]$col <- "#000000"
nys.haps[nys.haps$line=="45m58m",]$col <- "#000000"

ypd.haps$col <- NA
ypd.haps[ypd.haps$line=="wt",]$col <- "#BEBEBE"
ypd.haps[ypd.haps$line=="8m",]$col <- "#8B0000"
ypd.haps[ypd.haps$line=="12m",]$col <- "#87CEEB"
ypd.haps[ypd.haps$line=="45m",]$col <- "#FFD700"
ypd.haps[ypd.haps$line=="58m",]$col <- "#008B00"
ypd.haps[ypd.haps$line=="8m12m",]$col <- "#000000"
ypd.haps[ypd.haps$line=="8m45m",]$col <- "#000000"
ypd.haps[ypd.haps$line=="8m58m",]$col <- "#000000"
ypd.haps[ypd.haps$line=="12m45m",]$col <- "#000000"
ypd.haps[ypd.haps$line=="12m58m",]$col <- "#000000"
ypd.haps[ypd.haps$line=="45m58m",]$col <- "#000000"

nys.dips$col <- NA
nys.dips[nys.dips$line=="wt",]$col <- "#BEBEBE"
nys.dips[nys.dips$line=="8m",]$col <- "#8B0000"
nys.dips[nys.dips$line=="12m",]$col <- "#87CEEB"
nys.dips[nys.dips$line=="45m",]$col <- "#FFD700"
nys.dips[nys.dips$line=="58m",]$col <- "#008B00"
nys.dips[nys.dips$line=="8m12m",]$col <- "#000000"
nys.dips[nys.dips$line=="8m45m",]$col <- "#000000"
nys.dips[nys.dips$line=="8m58m",]$col <- "#000000"
nys.dips[nys.dips$line=="12m45m",]$col <- "#000000"
nys.dips[nys.dips$line=="12m58m",]$col <- "#000000"
nys.dips[nys.dips$line=="45m58m",]$col <- "#000000"

ypd.dips$col <- NA
ypd.dips[ypd.dips$line=="wt",]$col <- "#BEBEBE"
ypd.dips[ypd.dips$line=="8m",]$col <- "#8B0000"
ypd.dips[ypd.dips$line=="12m",]$col <- "#87CEEB"
ypd.dips[ypd.dips$line=="45m",]$col <- "#FFD700"
ypd.dips[ypd.dips$line=="58m",]$col <- "#008B00"
ypd.dips[ypd.dips$line=="8m12m",]$col <- "#000000"
ypd.dips[ypd.dips$line=="8m45m",]$col <- "#000000"
ypd.dips[ypd.dips$line=="8m58m",]$col <- "#000000"
ypd.dips[ypd.dips$line=="12m45m",]$col <- "#000000"
ypd.dips[ypd.dips$line=="12m58m",]$col <- "#000000"
ypd.dips[ypd.dips$line=="45m58m",]$col <- "#000000"

nys.dips.t$col <- NA
ypd.dips.t$col <- NA
lines <- c("812d", "8m12t", "8t12m", "8t12t", "845d", "8m45t", "8t45m", "8t45t", "858d","8m58t", "8t58m", "8t58t", "1245d", "12m45t", "12t45m", "12t45t", "1258d","12m58t", "12t58m","12t58t", "4558d", "45m58t", "45t58m", "45t58t", "8t","12t", "45t", "58t")
cols <- c("#000000", "#460000", "#446776", "#5F5F5F", "#000000", "#460000", "#806C00", "#5F5F5F", "#000000","#460000", "#004600", "#5F5F5F", "#000000", "#446776", "#806C00", "#5F5F5F", "#000000","#446776", "#004600","#5F5F5F", "#000000", "#806C00", "#004600", "#5F5F5F", "#A55F5F","#A3C6D5", "#DFCB5F", "#5FA55F")
#'only take the subset of the diploids that are heterozygotes
lines.t <- lines[grep("t", lines)]
cols.t <- cols[grep("t", lines)]

for (i in 1:length(lines.t)){
  nys.dips.t[nys.dips.t$line==lines.t[i],]$col <- cols.t[i]
  ypd.dips.t[ypd.dips.t$line==lines.t[i],]$col <- cols.t[i]
}

#'write function to make plots
plot_pair <- function(data, sngl1, dbl, sngl2, wt){
  plot(c(1,2,3), type="n", ylim=c(-2,1), xlim=c(0.5,3.5), xaxt="n", yaxt="n", ylab="")
  lines(c(1,2), c(data[data$line==sngl1,]$lsmean,data[data$line==dbl,]$lsmean), lty=data[data$line==dbl,]$lty1)
  lines(c(2,3), c(data[data$line==dbl,]$lsmean,data[data$line==sngl2,]$lsmean), lty=data[data$line==dbl,]$lty2)
  lines(c(1,2), c(data[data$line==sngl1,]$lsmean,data[data$line==wt,]$lsmean), lty=data[data$line==sngl1,]$lty1)
  lines(c(2,3), c(data[data$line==wt,]$lsmean,data[data$line==sngl2,]$lsmean), lty=data[data$line==sngl2,]$lty1)
  points(1, data[data$line==sngl1,]$lsmean, pch=16, col=data[data$line==sngl1,]$col, cex=2)
  arrows(1, data[data$line==sngl1,]$lower.CL, 1, data[data$line==sngl1,]$upper.CL,length=0, col="black")
  points(2, data[data$line==dbl,]$lsmean, pch=16, col=data[data$line==dbl,]$col, cex=2)
  arrows(2, data[data$line==dbl,]$lower.CL, 2, data[data$line==dbl,]$upper.CL,length=0, col="black")
  points(3, data[data$line==sngl2,]$lsmean, pch=16, col=data[data$line==sngl2,]$col, cex=2)
  arrows(3, data[data$line==sngl2,]$lower.CL, 3, data[data$line==sngl2,]$upper.CL,length=0, col="black")
  points(2, data[data$line==wt,]$lsmean, pch=16, col=data[data$line==wt,]$col, cex=2)
  arrows(2, data[data$line==wt,]$lower.CL, 2, data[data$line==wt,]$upper.CL,length=0, col="black")
  points(2, data[data$line==sngl1,]$lsmean+data[data$line==sngl2,]$lsmean-(data[data$line==wt,]$lsmean), pch=4, col="black", cex=2)
}

#####PLOT ALL OPTICAL DENSITIES IN TABLES - HAPLOIDS#####
#'Generates S1 Fig
pdf("Figures/HapODPlot.S1Fig.pdf", width=7.5, height=6, family="ArialMT", pointsize=10)

par(mfrow=c(4,4), mar=c(0,0,0,0), oma=c(4,5,4,15))

#'erg3-erg3 (nbm45-nbm45)
plot(1, type="n", axes=F, xlab="", ylab="")
text(1,1,labels="erg3", cex=3, col=nys.haps[nys.haps$line=="45m",]$col)

#'erg3-erg5 (nbm45-nbm58)
plot_pair(nys.haps, "45m", "45m58m", "58m", "wt")

#'erg3-erg6 (nbm45-nbm8)
plot_pair(nys.haps, "45m", "8m45m", "8m", "wt")
text(3,0.5,"S", cex=2, font=2)

#'erg3-erg7 (nbm45-nbm12)
plot_pair(nys.haps, "45m", "12m45m", "12m", "wt")
text(3,0.5,"S", cex=2, font=2)
axis(4, las=1, labels=c(0.05,0.1,0.2,0.4,0.8,1.6),at=c(log(0.05),log(0.1),log(0.2),log(0.4),log(0.8),log(1.6)))

#'erg3-erg5 (nbm45-nbm58) - ypd
plot_pair(ypd.haps, "45m", "45m58m", "58m", "wt")
axis(2, las=1, labels=c(0.05,0.1,0.2,0.4,0.8,1.6),at=c(log(0.05),log(0.1),log(0.2),log(0.4),log(0.8),log(1.6)))

#'erg5-erg5 (nbm58-nbm58)
plot(1, type="n", axes=F, xlab="", ylab="")
text(1,1,labels="erg5", cex=3, col=nys.haps[nys.haps$line=="58m",]$col)

#'erg5-erg6 (nbm58-nbm8) 
plot_pair(nys.haps, "58m", "8m58m", "8m", "wt")

#'erg5-erg7 (nbm58-nbm12)
plot_pair(nys.haps, "58m", "12m58m", "12m", "wt")
axis(4, las=1, labels=c(0.05,0.1,0.2,0.4,0.8,1.6),at=c(log(0.05),log(0.1),log(0.2),log(0.4),log(0.8),log(1.6)))

#'erg3-erg6 (nbm45-nbm8) - ypd
plot_pair(ypd.haps, "45m", "8m45m", "8m", "wt")
axis(2, las=1, labels=c(0.05,0.1,0.2,0.4,0.8,1.6),at=c(log(0.05),log(0.1),log(0.2),log(0.4),log(0.8),log(1.6)))

#'erg5-erg6 (nbm58-nbm8) - ypd
plot_pair(ypd.haps, "58m", "8m58m", "8m", "wt")

#'erg6-erg6 (nbm8-nbm8) 
plot(1, type="n", axes=F, xlab="", ylab="")
text(1,1,labels="erg6", cex=3, col=nys.haps[nys.haps$line=="8m",]$col)

#'erg6-erg7 (nbm8-nbm12)
plot_pair(nys.haps, "8m", "8m12m", "12m", "wt")
text(3,0.5,"S", cex=2, font=2)
axis(4, las=1, labels=c(0.05,0.1,0.2,0.4,0.8,1.6),at=c(log(0.05),log(0.1),log(0.2),log(0.4),log(0.8),log(1.6)))

#'erg3-erg7 (nbm45-nbm12) - ypd
plot_pair(ypd.haps, "45m", "12m45m", "12m", "wt")
axis(2, las=1, labels=c(0.05,0.1,0.2,0.4,0.8,1.6),at=c(log(0.05),log(0.1),log(0.2),log(0.4),log(0.8),log(1.6)))

#'erg5-erg7 (nbm58-nbm12) - ypd
plot_pair(ypd.haps, "58m", "12m58m", "12m", "wt")

#'erg6-erg7 (nbm8-nbm12) - ypd
plot_pair(ypd.haps, "8m", "8m12m", "12m", "wt")

#'erg7-erg7 (nbm12-nbm12)
plot(1, type="n", axes=F, xlab="", ylab="")
text(1,1,labels="erg7", cex=3, col=nys.haps[nys.haps$line=="12m",]$col)

#'add text
mtext("Optical Density after 24hr", side=2, line=3.2, adj=0.5, cex=1.2,  outer=TRUE) 
mtext("Nystatin", side=3, line=1.3, adj=0.65, cex=1.5,  outer=TRUE) 
mtext("YPD", side=1, line=2, adj=0.37, cex=1.5,  outer=TRUE) 

#'add lines for YPD heading
arrows(-1.6,0.51,0.13,0.51,length=0,col="black",xpd=NA, lwd=3)
arrows(-1.6,0.51,-1.6,0.56,length=0,col="black",xpd=NA, lwd=3)
arrows(0.13,0.51,0.13,0.56,length=0,col="black",xpd=NA, lwd=3)
#'add lines for nystatin heading
arrows(-0.72,4.08,1.01,4.08,length=0,col="black",xpd=NA, lwd=3)
arrows(-0.72,4.08,-0.72,4.03,length=0,col="black",xpd=NA, lwd=3)
arrows(1.01,4.08,1.01,4.03,length=0,col="black",xpd=NA, lwd=3)
#'add legend
legend(1.65,2.84,c("wildtype","hypothetical double", "mutant (no epistasis)","double mutant","erg3 single mutant","erg5 single mutant","erg6 single mutant","erg7 single mutant"),pch=c(16,4,NA,16,16,16,16,16), bty="n", xpd=NA, col=c("#BEBEBE","#000000",NA,"#000000","#FFD700","#008B00","#8B0000","#87CEEB"), pt.cex=2, x.intersp = 0.8,y.intersp = c(1.4,1.4,1.3,1.4,1.4,1.4,1.4,1.4), cex=1.25)

#'open the plot
dev.off()
system("open Figures/HapODPlot.S1Fig.pdf")

#####PLOT ALL OPTICAL DENSITIES IN TABLES - DIPLOIDS#####
#'write function to make plots
plot_pair_dip <- function(data, sngl1, dbl, sngl2, wt, hetdata, t1, m1t2, t2, m2t1, t1t2){
  plot(c(1,2,3), type="n", ylim=c(-2,1), xlim=c(0.5,3.5), xaxt="n", yaxt="n", ylab="")
  lines(c(1,2), c(data[data$line==sngl1,]$lsmean,data[data$line==dbl,]$lsmean), lty=data[data$line==dbl,]$lty1)
  lines(c(2,3), c(data[data$line==dbl,]$lsmean,data[data$line==sngl2,]$lsmean), lty=data[data$line==dbl,]$lty2)
  lines(c(1,2), c(data[data$line==sngl1,]$lsmean,data[data$line==wt,]$lsmean), lty=data[data$line==sngl1,]$lty1)
  lines(c(2,3), c(data[data$line==wt,]$lsmean,data[data$line==sngl2,]$lsmean), lty=data[data$line==sngl2,]$lty1)
  points(1, data[data$line==sngl1,]$lsmean, pch=16, col=data[data$line==sngl1,]$col, cex=2)
  arrows(1, data[data$line==sngl1,]$lower.CL, 1, data[data$line==sngl1,]$upper.CL,length=0, col="black")
  points(2, data[data$line==dbl,]$lsmean, pch=16, col=data[data$line==dbl,]$col, cex=2)
  arrows(2, data[data$line==dbl,]$lower.CL, 2, data[data$line==dbl,]$upper.CL,length=0, col="black")
  points(3, data[data$line==sngl2,]$lsmean, pch=16, col=data[data$line==sngl2,]$col, cex=2)
  arrows(3, data[data$line==sngl2,]$lower.CL, 3, data[data$line==sngl2,]$upper.CL,length=0, col="black")
  points(2, data[data$line==wt,]$lsmean, pch=16, col=data[data$line==wt,]$col, cex=2)
  arrows(2, data[data$line==wt,]$lower.CL, 2, data[data$line==wt,]$upper.CL,length=0, col="black")
  points(1.5, hetdata[hetdata$line==t1,]$lsmean, pch=2, cex=1.5, col=hetdata[hetdata$line==t1,]$col)
  arrows(1.5, hetdata[hetdata$line==t1,]$lower.CL, 1.5, hetdata[hetdata$line==t1,]$upper.CL,length=0, col="black")
  points(2.5, hetdata[hetdata$line==t2,]$lsmean, pch=2, cex=1.5, col=hetdata[hetdata$line==t2,]$col)
  arrows(2.5, hetdata[hetdata$line==t2,]$lower.CL, 2.5, hetdata[hetdata$line==t2,]$upper.CL,length=0, col="black")
  points(1.5, hetdata[hetdata$line==m1t2,]$lsmean, pch=1, cex=1.5, col=hetdata[hetdata$line==m1t2,]$col)
  arrows(1.5, hetdata[hetdata$line==m1t2,]$lower.CL, 1.5, hetdata[hetdata$line==m1t2,]$upper.CL,length=0, col="black")
  points(2.5, hetdata[hetdata$line==m2t1,]$lsmean, pch=1, cex=1.5, col=hetdata[hetdata$line==m2t1,]$col)
  arrows(2.5, hetdata[hetdata$line==m2t1,]$lower.CL, 2.5, hetdata[hetdata$line==m2t1,]$upper.CL,length=0, col="black")
  points(2, hetdata[hetdata$line==t1t2,]$lsmean, pch=5, cex=1.5, col=hetdata[hetdata$line==t1t2,]$col)
  arrows(2, hetdata[hetdata$line==t1t2,]$lower.CL, 2, hetdata[hetdata$line==t1t2,]$upper.CL,length=0, col="black")
}

#'Generates S2 Fig
pdf("Figures/DipODPlot.S2Fig.pdf", width=7.5, height=6, family="ArialMT", pointsize=10)

par(mfrow=c(4,4), mar=c(0,0,0,0), oma=c(4,5,4,15))

#'erg3-erg3 (nbm45-nbm45)
plot(1, type="n", axes=F, xlab="", ylab="")
text(1,1,labels="erg3", cex=3, col=nys.dips[nys.dips$line=="45m",]$col)

#'erg3-erg5 (nbm45-nbm58)
plot_pair_dip(nys.dips, "45m", "45m58m", "58m", "wt", nys.dips.t, "45t", "45m58t", "58t", "45t58m", "45t58t")

#'erg3-erg6 (nbm45-nbm8)
plot_pair_dip(nys.dips, "45m", "8m45m", "8m", "wt", nys.dips.t, "45t", "8t45m", "8t", "8m45t", "8t45t")

#'erg3-erg7 (nbm45-nbm12)
plot_pair_dip(nys.dips, "45m", "12m45m", "12m", "wt", nys.dips.t, "45t", "12t45m", "12t", "12m45t", "12t45t")
text(3,0.5,"S", cex=2, font=2)
axis(4, las=1, labels=c(0.05,0.1,0.2,0.4,0.8,1.6),at=c(log(0.05),log(0.1),log(0.2),log(0.4),log(0.8),log(1.6)))

#'erg3-erg5 (nbm45-nbm58) - ypd
plot_pair_dip(ypd.dips, "45m", "45m58m", "58m", "wt", ypd.dips.t, "45t", "45m58t", "58t", "45t58m", "45t58t")
axis(2, las=1, labels=c(0.05,0.1,0.2,0.4,0.8,1.6),at=c(log(0.05),log(0.1),log(0.2),log(0.4),log(0.8),log(1.6)))

#'erg5-erg5 (nbm58-nbm58)
plot(1, type="n", axes=F, xlab="", ylab="")
text(1,1,labels="erg5", cex=3, col=nys.dips[nys.dips$line=="58m",]$col)

#'erg5-erg6 (nbm58-nbm8) 
plot_pair_dip(nys.dips, "58m", "8m58m", "8m", "wt", nys.dips.t, "58t", "8t58m", "8t", "8m58t", "8t58t")

#'erg5-erg7 (nbm58-nbm12)
plot_pair_dip(nys.dips, "58m", "12m58m", "12m", "wt", nys.dips.t, "58t", "12t58m", "12t", "12m58t", "12t58t")
axis(4, las=1, labels=c(0.05,0.1,0.2,0.4,0.8,1.6),at=c(log(0.05),log(0.1),log(0.2),log(0.4),log(0.8),log(1.6)))

#'erg3-erg6 (nbm45-nbm8) - ypd
plot_pair_dip(ypd.dips, "45m", "8m45m", "8m", "wt", ypd.dips.t, "45t", "8t45m", "8t", "8m45t", "8t45t")
axis(2, las=1, labels=c(0.05,0.1,0.2,0.4,0.8,1.6),at=c(log(0.05),log(0.1),log(0.2),log(0.4),log(0.8),log(1.6)))

#'erg5-erg6 (nbm58-nbm8) - ypd
plot_pair_dip(ypd.dips, "58m", "8m58m", "8m", "wt", ypd.dips.t, "58t", "8t58m", "8t", "8m58t", "8t58t")

#'erg6-erg6 (nbm8-nbm8) 
plot(1, type="n", axes=F, xlab="", ylab="")
text(1,1,labels="erg6", cex=3, col=nys.dips[nys.dips$line=="8m",]$col)

#'erg6-erg7 (nbm8-nbm12)
plot_pair_dip(nys.dips, "8m", "8m12m", "12m", "wt", nys.dips.t, "8t", "8m12t", "12t", "8t12m", "8t12t")
text(3,0.5,"RS", cex=2, font=2)
axis(4, las=1, labels=c(0.05,0.1,0.2,0.4,0.8,1.6),at=c(log(0.05),log(0.1),log(0.2),log(0.4),log(0.8),log(1.6)))

#'erg3-erg7 (nbm45-nbm12) - ypd
plot_pair_dip(ypd.dips, "45m", "12m45m", "12m", "wt", ypd.dips.t, "45t", "12t45m", "12t", "12m45t", "12t45t")
axis(2, las=1, labels=c(0.05,0.1,0.2,0.4,0.8,1.6),at=c(log(0.05),log(0.1),log(0.2),log(0.4),log(0.8),log(1.6)))

#'erg5-erg7 (nbm58-nbm12) - ypd
plot_pair_dip(ypd.dips, "58m", "12m58m", "12m", "wt", ypd.dips.t, "58t", "12t58m", "12t", "12m58t", "12t58t")

#'erg6-erg7 (nbm8-nbm12) - ypd
plot_pair_dip(ypd.dips, "8m", "8m12m", "12m", "wt", ypd.dips.t, "8t", "8m12t", "12t", "8t12m", "8t12t")

#'erg7-erg7 (nbm12-nbm12)
plot(1, type="n", axes=F, xlab="", ylab="")
text(1,1,labels="erg7", cex=3, col=nys.dips[nys.dips$line=="12m",]$col)

#'add text
mtext("Optical Density after 24hr", side=2, line=3.2, adj=0.5, cex=1.2,  outer=TRUE) 
mtext("Nystatin", side=3, line=1.3, adj=0.65, cex=1.5,  outer=TRUE) 
mtext("YPD", side=1, line=2, adj=0.37, cex=1.5,  outer=TRUE) 

#'add lines for YPD heading
arrows(-1.6,0.51,0.13,0.51,length=0,col="black",xpd=NA, lwd=3)
arrows(-1.6,0.51,-1.6,0.56,length=0,col="black",xpd=NA, lwd=3)
arrows(0.13,0.51,0.13,0.56,length=0,col="black",xpd=NA, lwd=3)
#'add lines for nystatin heading
arrows(-0.72,4.08,1.01,4.08,length=0,col="black",xpd=NA, lwd=3)
arrows(-0.72,4.08,-0.72,4.03,length=0,col="black",xpd=NA, lwd=3)
arrows(1.01,4.08,1.01,4.03,length=0,col="black",xpd=NA, lwd=3)
#'add legend
legend(1.65,3.06,c("wildtype","double mutant","erg3 single mutant","erg5 single mutant","erg6 single mutant","erg7 single mutant","double heterozygote","single heterozygote", "other gene wt","single heterozygote", "other gene mutant"),pch=c(16,16,16,16,16,16,5,2,NA,1,NA), bty="n", xpd=NA, col=c("#BEBEBE","#000000","#FFD700","#008B00","#8B0000","#87CEEB","#000000","#000000",NA,"#000000",NA), pt.cex=c(2,2,2,2,2,2,1.5,1.5,1.5,1.5,1.5), x.intersp = 0.8,y.intersp = c(1.4,1.4,1.4,1.4,1.4,1.4,1.4,1.4,1.37,1.4,1.37), cex=1.25)

#'open the plot
dev.off()
system("open Figures/DipODPlot.S2Fig.pdf")



